package dareka;

public class Config {
    private int listenPort;
    private String proxyHost;
    private int proxyPort;
    private boolean title;

    public int getListenPort() {
        return listenPort;
    }

    public void setListenPort(int listenPort) {
        if (listenPort < 1 || 65535 < listenPort) {
            throw new IllegalArgumentException("invalid listen port: "
                    + listenPort);
        }
        this.listenPort = listenPort;
    }

    public String getProxyHost() {
        return proxyHost;
    }

    public void setProxyHost(String proxyHost) {
        this.proxyHost = proxyHost;
    }

    public int getProxyPort() {
        return proxyPort;
    }

    public void setProxyPort(int proxyPort) {
        if (proxyPort < 1 || 65535 < proxyPort) {
            throw new IllegalArgumentException("invalid proxy port: "
                    + proxyPort);
        }
        this.proxyPort = proxyPort;
    }

    public boolean isTitle() {
        return title;
    }

    public void setTitle(boolean title) {
        this.title = title;
    }
}
