package dareka.launcher;

import java.awt.Desktop;
import java.awt.Image;
import java.awt.MenuItem;
import java.awt.PopupMenu;
import java.awt.SystemTray;
import java.awt.TrayIcon;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.io.FileOutputStream;
import java.io.PrintStream;
import java.net.URL;
import java.util.Date;

import javax.swing.ImageIcon;

public class LauncherMain {

	// o[W
	private static final String VER_STRING = "NicoCacheGUI v0.05";

	// o[W̃ANZbT
	public static String getVersion() {
		return VER_STRING;
	}

	// ***********************************
	// \[X͎኱蔲EEE
	// ݂̃\[XJȂJƁA\͂ŉbĂ悤Ȋł낢ˁB
	// ***********************************

	private static final String URL_NICO_TOP = "http://www.nicovideo.jp/";
	private static final String URL_NICO_CACHE = URL_NICO_TOP + "cache/";

	private static SystemTray f_tray;
	private static TrayIcon f_trayIcon;

	private static PrintStream f_psLog;
	private static PrintStream org_out;
	private static PrintStream org_err;

	public static void main(String[] args) throws Exception {

		// TODO Exceptioncatch܂傤AB

		// R}hvvgȂ̂ŁAStdOut StdErr Ot@Cɑ
		f_psLog = new PrintStream(new FileOutputStream("log.txt", true));
		org_out = System.out;
		org_err = System.err;
		System.setOut(f_psLog);
		System.setErr(f_psLog);

		// VXegC̃T|[gmFACX^X擾B
		// TODO î܂܂ƃNXꍇ(JRE5Ƃ)炵B΍͌񂵁Bj
		if (SystemTray.isSupported() == false) {
			System.out.println("VXegCT|[gĂ܂B");
			System.out.println("JavaŐV(Version6.0ȍ~)mFĂB");
			System.exit(0);
		}
		f_tray = SystemTray.getSystemTray();

		System.out.println("");
		System.out.println("---" + VER_STRING + " Start:" + new Date() + "---");

		// VER_STRING ̎擾
		// ({ƑΉ̂ŁAreflectƂȂł܂B)
		String strVerString = dareka.Main.getVersion();

		// ACR摜̎擾
		URL url = LauncherMain.class.getResource("Icon.gif");
		ImageIcon imgicon = new ImageIcon(url);
		Image img = imgicon.getImage();

		// ^XNgCPopupMenu쐬
		PopupMenu popup = new PopupMenu();

		MenuItem menuhome = new MenuItem("jRjRJ");
		menuhome.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				try {
					// uEUJ
					Desktop.getDesktop().browse(new URL(URL_NICO_TOP).toURI());
				} catch (Exception ex) {
					ex.printStackTrace();
				}
			}
		});
		popup.add(menuhome);

		if (strVerString.startsWith("NicoCache_nl")) {
			MenuItem menucache = new MenuItem("LbV\");
			menucache.addActionListener(new ActionListener() {
				public void actionPerformed(ActionEvent e) {
					try {
						// uEUJ
						Desktop.getDesktop().browse(
								new URL(URL_NICO_CACHE).toURI());
					} catch (Exception ex) {
						ex.printStackTrace();
					}
				}
			});
			popup.add(menucache);
		}

		popup.addSeparator();

		// {̂̃vO擾
		String strProgName;
		if (strVerString.matches("^NicoCache v[0-9\\.]+p[0-9]*$")) {
			// o[W\LNicoCache_p̏ꍇA"NicoCache_p"Ƃ
			strProgName = "NicoCache_p";
		} else {
			// ŏ̔pXy[XȑOvOƂĎ擾
			int intNameTail = strVerString.indexOf(' ');
			if (intNameTail == -1) {
				// oꂷ邩ȂhłlāAŒG[ɂȂȂ悤ɂĂ
				strProgName = strVerString;
			} else {
				strProgName = strVerString.substring(0, intNameTail);
			}
		}

		MenuItem menuexit = new MenuItem(strProgName + " ̏I");
		menuexit.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				// NicoCache{̂~
				dareka.Main.stop();
				// VXegC̃ACR폜
				f_tray.remove(f_trayIcon);
				
				System.out.println("---" + VER_STRING + " End:" + new Date() + "---");
				//System.exit(0);
			}
		});
		popup.add(menuexit);

		// VXegCACR̍쐬
		f_trayIcon = new TrayIcon(img, strVerString, popup);
		f_trayIcon.setImageAutoSize(true);

		// ACR_uNbN̓ɂ
		if (strVerString.startsWith("NicoCache_nl")) {
			// NicoCache_nl ȂAACR_uNbNŃLbVy[WJ
			f_trayIcon.addActionListener(new ActionListener() {
				public void actionPerformed(ActionEvent e) {
					try {
						// uEUJ
						Desktop.getDesktop().browse(
								new URL(URL_NICO_CACHE).toURI());
					} catch (Exception ex) {
						ex.printStackTrace();
					}
				}
			});
		} else {
			// LȊO NicoCache ȂAACR_uNbNŃgbvy[WJ
			f_trayIcon.addActionListener(new ActionListener() {
				public void actionPerformed(ActionEvent e) {
					try {
						// uEUJ
						Desktop.getDesktop().browse(
								new URL(URL_NICO_TOP).toURI());
					} catch (Exception ex) {
						ex.printStackTrace();
					}
				}
			});
		}

		// VXegC̃ACRǉ
		f_tray.add(f_trayIcon);

		// NicoCache{̋NI
		dareka.Main.main(args);

	}

	@Override
	protected void finalize() throws Throwable {

		// Ot@Co͂~
		System.setErr(org_err);
		System.setOut(org_out);
		f_psLog.close();
		f_psLog = null;

		super.finalize();
	}

}
